;===============================================================================
; Object 4F - Splats
;===============================================================================
Obj4F:
        moveq   #0,d0
        move.b  $24(a0),d0
        move.w  Obj4F_Index(pc,d0.w),d1
        jmp     Obj4F_Index(pc,d1.w)

;-------------------------------------------------------------------------------
Obj4F_Index:
        dc.w    Obj4F_Init-Obj4F_Index
        dc.w    Obj4F_Action-Obj4F_Index
        dc.w    Obj4F_Bounce2-Obj4F_Index
;-------------------------------------------------------------------------------
Obj4F_Init:
        move.l  #Map_Obj4F,4(a0)
        move.w  #$448,2(a0)
        move.b  #4,1(a0)
        move.b  #4,$18(a0)
        move.b  #$15,$19(a0)
        move.b  #$13,$16(a0)
        move.b  #$B,$17(a0)
        move.b  #$C,$20(a0)
        addq.b  #2,$24(a0)
        move.b  #$40,$26(a0)
        move.w  #$FF00,$10(a0)
        move.w  #$100,$12(a0)
        rts                                                            
;-------------------------------------------------------------------------------
Obj4F_Action:
        bsr.w     ObjectFall
        bsr.s     Obj4F_ChkLeftWall
        bsr.w     Splats_chkframe
        bra.w     MarkObjGone

Obj4F_ChkLeftWall:
        moveq   #0,d3
        move.b  $19(a0),d3
        tst.w   $10(a0)
        bpl.s   Obj4F_ChkRightWall
        neg.w   d3
        bsr.w   ObjHitWallLeft
        addq.w  #8,d1 ; wall turning looks bad without this
        tst.w   d1
        bmi.s   Obj4F_TurnAround
        move.w  8(a0),d1
        subi.w  #$C,d1
        bgt.s   Obj4F_Bounce
        bra.s   Obj4F_TurnAround

Obj4F_ChkRightWall:
        bsr.w   ObjHitWallRight
        addq.w  #8,d1 ; wall turning looks bad without this
        tst.w   d1
        bmi.s   Obj4F_TurnAround
        move.w  ($FFFFF72A).w,d1
        subi.w  #$C,d1
        sub.w   8(a0),d1
        bgt.s   Obj4F_Bounce

Obj4F_TurnAround:
        add.w   d1,8(a0)
        neg.w   $10(a0)
        bchg    #0,$22(a0)
        bchg    #0,1(a0) ; x-flip graphics

Obj4F_Bounce:
        bsr.w   ObjHitFloor
        tst.w   d1
        bpl.s   @return
        add.w   d1,$C(a0)
        move.w  #$FA00,$12(a0)
        addq.b  #2,$24(a0) ; make sure it only executes Bounce2 next frame
        rts

Obj4F_Bounce2:
        move.b  #1,$1A(a0) ; switch to frame 1
        move.b  #$1C,$1E(a0) ; set counter to frame 0
        subq.b  #2,$24(a0) ; go back to regular routine
        bra.w   MarkObjGone

Splats_chkframe:
        subq.b   #1,$1E(a0) ; subtract 1 from frame counter
        bne.s    @return ; if not 0 ignore
        clr.b    $1A(a0) ; if zero go back to frame 0


@return:
        rts

;===============================================================================
; Splats Mappings and Animations
;===============================================================================

Map_Obj4F:
        include "_maps\Obj4F.asm"

